import sys
sys.path[1] = '/opt/anaconda2/lib/python2.7/site-packages/'
import numpy as np
import struct
from scipy.sparse import coo_matrix,save_npz
import math
from scipy import sparse
import time

def readTrace(infile,nSamples,dataLen,endian,nSamplesToRead):
    '''infile is .H, nSamples is the number of samples per sensor, and traceNumber is the sensor number (start with 1),dataLen is number of bytes per data sample'''
    fin = open(infile, 'rb') # open file for reading binary mode
    startData = 0
    fin.seek(startData)
    thisDataBinary = fin.read(nSamplesToRead*dataLen) # read binary bytes from file
    fin.close()
    thisDataArray = struct.unpack_from(endian+('f')*nSamplesToRead,thisDataBinary) # get data as a tuple of floats
    return np.asarray(thisDataArray,dtype=np.float32)

def readHeader(fileName):
        f = open(fileName,'r')
        n1 = 0
        n2 = 0
        dataFileName = ''
        for text in f:
                if 'in=' in text:
                        idx = text.find("in")
                        dataFileName = text[idx+3:-1]
                if 'n1=' in text:
                        #print(text)
                        startIdx = text.find('n1=') + 3
                        endIdx = text.find(' ', startIdx)
                        n1 = int(text[startIdx:endIdx])
                if 'n2=' in text:
			startIdx = text.find('n2=') + 3
                        endIdx = text.find(' ', startIdx)
                        n2 = int(text[startIdx:endIdx])
        return dataFileName, n1, n2

def saveModel(outputFileName,model):
    with open(outputFileName,'w') as f:
        f.write('in='+outputFileName+'@\n n1='+str(naz)+' o1='+str(oaz)+' d1='+str(daz)+'\n')
        f.write('n2='+str(nslo)+' o2='+str(oslo)+' d2='+str(dslo)+'\n')
        f.write('n3='+str(nwave)+' o3='+str(owave)+' d3='+str(dwave)+'\n')
        f.write('n4='+str(nt0)+' o4='+str(ot0)+' d4='+str(dt0)+'\n')
        f.write('gff="-1" hff="-1"\n')

    with open(outputFileName+'@','wb') as newFile:
        rt = model.astype(np.float32)
        rt.byteswap(True)
        newByteArray = bytearray(rt)
        newFile.write(newByteArray)
    print "<<<<<<<<<<results saved!"

# output data file name
dataFile = sys.argv[1]
FopFile = sys.argv[2]
outputFileName = sys.argv[3]
data_par_path = sys.argv[4]
model_par_path = sys.argv[5]
sys.path.append(data_par_path)
from par import *
sys.path.remove(data_par_path)
sys.path.append(model_par_path)
from wavePar import *
sys.path.remove(model_par_path)

# load operator (spase matrix)
Fop = sparse.load_npz(FopFile)

# read data
print dataFile
binFile, nt, nch = readHeader(dataFile)
print binFile, nt, nch
data = readTrace(binFile, nt*nch, 4, '>', nt*nch)
data = data.reshape((nch,nt))
data = data.T
data = data.reshape((data.size,1))

# compute model
print 'computing the data!'
model = Fop.T.dot(data)
model = model.reshape((naz,nslo,nwave,nt0))
model = model.T
model = model.reshape((model.size,1))
print 'computing is complete!'
print 'saving!'
saveModel(outputFileName,model)
print 'saved!'
