import sys
sys.path[1] = '/opt/anaconda2/lib/python2.7/site-packages/'
import numpy as np
import struct
from scipy.sparse import coo_matrix,save_npz
import math
from scipy import sparse
import time
from sklearn.linear_model import Lasso
from sklearn.linear_model import Ridge
from sklearn.linear_model import LinearRegression
sys.path.append("/net/server2/homes/sep/syyuan/septool/")
from readSEPfile import *

def saveModel(outputFileName,model):
	with open(outputFileName,'w') as f:
		f.write('in='+outputFileName+'@\n n1='+str(naz)+' o1='+str(oaz)+' d1='+str(daz)+'\n')
		f.write('n2='+str(nslo)+' o2='+str(oslo)+' d2='+str(dslo)+'\n')
		f.write('n3='+str(nwave)+' o3='+str(owave)+' d3='+str(dwave)+'\n')
		f.write('n4='+str(nt0)+' o4='+str(dt0)+' d4='+str(dt0)+'\n')
		f.write('gff="-1" hff="-1"\n')

	with open(outputFileName+'@','wb') as newFile:
		rt = model.astype(np.float32)
		rt.byteswap(True)
		newByteArray = bytearray(rt)
		newFile.write(newByteArray)
	print "<<<<<<<<<<results saved!"
	

# data file name
dataFileHeader = sys.argv[1]
# operator file name
FopFile = sys.argv[2]
# output file name
outputFile = sys.argv[3]
method = sys.argv[4]
alpha = 1e-6
alpha = float(sys.argv[5])
data_par_path = sys.argv[6]
sys.path.append(data_par_path)
from par import *
model_par_path = sys.argv[7]
sys.path.append(model_par_path)
from wavePar import *

# read data
binFile, nt, nch = readHeader(dataFileHeader)
data = readTrace(binFile, nt*nch, 4, '>', nt*nch)
data = data.reshape((nch,nt))
data = data.T
data = data.reshape((data.size,1))

# load operator (spase matrix)
Fop = sparse.load_npz(FopFile)
data = data.reshape((data.size,1))
tic = time.time()
print "<<<<<<<<<<Operator loaded!"
tic = time.time()
if method == 'lasso':
	mtd = Lasso(alpha=alpha, fit_intercept=False, max_iter=5000, selection='random')
elif method == 'ridge':
	mtd = Ridge(alpha=alpha, fit_intercept=False, solver='sag', max_iter=5000)
elif method == 'ls':
	mtd = LinearRegression(fit_intercept=False)
else:
	print 'Only support Lasso or Ridge!'
	sys.exit()
print "<<<<<<<<<<Start fitting!"
mtd.fit(Fop, data)
toc = time.time()

print 'fitting time is '+str(toc-tic)
coeff = mtd.coef_
coeff = coeff.reshape((naz,nslo,nwave,nt0))
coeff = coeff.T
saveModel(outputFile,coeff)
