import sys
sys.path[1] = '/opt/anaconda2/lib/python2.7/site-packages/'
import numpy as np
from scipy.sparse import coo_matrix,save_npz
import math
import sys
import re

# channel coorr file
chlistFile = sys.argv[1]
FopName = sys.argv[2]
data_space_par_path = sys.argv[3]
sys.path.append(data_space_par_path)
from par import * 

model_space_par_path = sys.argv[4]
sys.path.append(model_space_par_path)
from wavePar import * 

# read coordinates
coords = []
coords_sub = []
dirLs = []
ndir = 0
with open(chlistFile,'r') as f:
	chlistRead = f.readlines()
for line in chlistRead:
	if "=" in line:
		if ndir>0:
			coords.append(coords_sub)
		coords_sub = []
		idx = line.find("=")+1	
		dirLs.append(float(line[idx:]))
		ndir = ndir+1
	else:
		strs = re.split('\s|\t ', line)
		coords_sub.append([float(strs[1]),float(strs[2])])
coords.append(coords_sub)
coords = np.array(coords)

if (nch <> len(coords[0])+len(coords[1])):
	print "coords dimention is wrong!"
	sys.exit()

azLs = np.linspace(oaz,naz*daz,naz,endpoint=False)
sloLs = np.linspace(oslo,nslo*dslo,nslo,endpoint=False)
waveLs = np.linspace(owave,nwave*dwave,nwave,endpoint=False)
t0Ls = np.linspace(ot0,nt0*dt0,nt0,endpoint=False)

# m0
m0 = np.zeros((naz, nslo, nwave, nt0))

# defile operator (spase matrix)
FopCoef = []
dataCorr = []
modelCorr = []
print "now we compute and save the beamforming operator for the following computation..."
for it0, t0 in enumerate(t0Ls):
	print "t0: {} / {}".format(t0, t0Ls[-1])
	for iwave, wave in enumerate(waveLs):
		for islo, slo in enumerate(sloLs):
			for iaz, az in enumerate(azLs):
				ch = 0
				for idir in range(len(dirLs)):	
					direction = dirLs[idir]
					ang = (direction/180.)*math.pi-az
					if wave == 0:
						sc = math.cos(ang)*math.cos(ang) 
					elif wave == 1:
						sc = -math.sin(ang)*math.cos(ang)
					for ich,chnum in enumerate(coords[idir]):
						ta = t0+math.cos(az)*slo*(coords[idir][ich][0]-x0)+math.sin(az)*slo*(coords[idir][ich][1]-y0) 
						it = int((ta-ot)/dt)
						if it >=0 and it<nt-1:
							FopCoef.append(sc)
							dataCorr.append(ch+it*nch)
							modelCorr.append(it0+iwave*nt0+islo*nt0*nwave+iaz*nt0*nwave*nslo)
						ch = ch+1
Fop = coo_matrix((FopCoef,(dataCorr,modelCorr)), shape=(nt*nch,naz*nslo*nwave*nt0))
save_npz(FopName,Fop)
